disp_re = ''.join((
    '(?:(?:consent |default )?judgment|cash bond forfeiture|judgment on the pleadings|',
    'dismissal with(?:out)? prejudi(?:ce)?|warrantless arrest affidav?|dismissed for want of prosecut|',
    'amv order to sell vehicle|writ of possession (?:patho|forecl(?:os)?)|case closed|arrest warrant|',
    '(?:bound over|transfer) to (?:sup(?:erior|\.)|st(?:ate|\.)) (?:ct\.?|court)(?:, +(?:waver|fast tr))?|',
    'order/case closed-no trial|nolle prossed|consent docket to pay (?:pmts|payme(?:nts)?)|',
    'consent judgment \(for plt(?:f\))?|guilty plea(?: |-)negotiated|nolo contendere|nolo plea released to prob|',
    'dismissed for want of pro(?:se)?|closed after 5 year dormancy?|consent docket (?:for payments|to pay pay)|',
    'final decree(?: bench trial)?|bench trial judgment - (?:pl(?:tf)?|de(?:fdt?)?)|contempt order-domestic|',
    'garnishment 2 yr law\(18-4-6(?:3\))?|sentenced/first offender act|reggarn pd in full case com(?:ple)?|',
    'summary judgment granted pl(?:tf)?|notice of removal district|traffic citation dismissed|',
    'guilty released probation|removal and federal stay|bankruptcy stay granted|transfer out of county|',
    'congarn (?:not emp|\d{3} days exp|pd in full|released) case(?: c)?(?:omp?(?:le?)?(?:ted)?)?|',
    'crt adjudicated-judgment pl|dismissed by magistrate ct|jury verdict for (?:plaintiff|defendant)|',
    'first offender plea|traffic civil-judgment (?:pltf|def)|binding arbitration|paid in office,appeal dismi|',
    'final decree summary judgme|affidavit filed dismissed|dismissed|no bill|warr app denied - want of pros|',
    'order to domest foreign jme(?:nt)?)'
))

action_to_regex = {
    'general': '(?i)(?:\n|\d+(?::\d+)? ?(?:a|p)\.?m?\.? )(?:by|against|for|to|of) (.+)',
    'Party Added': '(?i)(.+)',
    'Party Removed': '(?i)(.+)',
    'Alias Added': '(?i)(.+)',
    'Clear Party Sts': '(?i)((?:(?! -).)+)(?:- bankruptcy dismissed)?',
    'Party Dismissed': '(?i)((?:(?! consent |(?: |\n)dis(?:m| )| w/?o | w/| with| as | drop | \\-).)+)(?:.+)?',
    'Court Appt Atty': '(?i)(?:atty .+(?:\nfor (.+))?|for (.+)\natty .+)(?:\n(?:.|\n)+)?',
    'Crt Apt Aty Rem': '(?i)(?:atty .+(?:\nfor (.+))?|for (.+)\natty .+)(?:\n(?:.|\n)+)?',
    'Crt App Aty Rem': '(?i)(?:atty .+(?:\nfor (.+))?|for (.+)\natty .+)(?:\n(?:.|\n)+)?',
    'Add Attorney': '(?i)(?:atty .+(?:\nfor (.+))?|for (.+)\natty .+)(?:\n(?:entry|notice) of appearance)?',
    'Remove Attorney': '(?i)(?:atty .+(?:\nfor (.+))?|for (.+)\natty .+)',
    'Case Filing': ''.join(('(?i)((?:(?! -).)+)(?<! ) +- (?:ct(?: \d+)?|no bill?)',
                            '(?=$|\n(?:(?:by|against|for|to|of) \\1|fast track))|',
                            '\n(?:by|against|for|to|of) (.+)|',
                            'arrest warrant\nfiled against (.+)')),
    'Service': ''.join(('(?i)(?:unable to serve|hung on door|hodo|pers(?:onal)?|corp(?:oration)?|none|noco|non-est|',
                      'most notorious place of abode|mn(?:p|f)a|evic(?:tion)?|ackn(?:owledgment of service)?|',
                      'moved no forwarding address|address not in clayton county|certificate of service|retd|',
                      'null(?:abona)?|none|cert|publ|garnishee served|affidavit of compliance garnis|afco|garn|',
                      'publication|sect|service thru sec of state)',
                      ',? (.+)(?:\n(?:[a-z0-9&,@:;/\.\-\'\(\)\{\}\? ]|\n)+)?')),
    'Sentence': ''.join(('(?i)(?:(?:\((.+)\))?(?:[^\(]|\n)*(?:\(((?:[^\)]|\n)+)\)|(?: |\n)(?:to|against) (.+))',
                 '(?:\nsentence)?(?:(?: |\n)(?:(?:revoke|continue):(?:[^\(]|\n)+|sp cond(?: |\n))',
                 '\(((?:[^\)]|\n)+)\))?|[a-z]{1,4}(?: \$?)?\d{1,3}(?:.|\n)*|nolle? prossed?|nps|',
                 '(?:sentence(?: |-))?ct [a-z0-9]+,? -? ?(?:\(\d+\))?(?:[^\(]|\n)+|\$\d+\.\d+ fine;.+|',
                 '\d{1,2}[a-z]{1,2}|sentence|dwop|defts plea statement(?:.|\n)+)')),
    'Final Case Disp':  ''.join((f'(?i)(?:(?:final case|case final) disp(?:osi?tio?n)?(?:(?: ?\- ?|\n){disp_re})?|{disp_re}|',
                                 '\*{3} old case - see paper file|rule nisi|fi fa)')),
    'Case Outcome': ''.join(('(?i)(?:[^0-9]+(?:under 16-13-2)? - cnt \d+ (?:accusation-)?|\n(?:by|against) )',
                             '(?!warrantless|accusation|uniform|arrest|indictment|county|traffic|criminal|bad check|no bill)',
                             '((?:(?! -).)+)(?<! )')),
    'Event Outcome': ''.join(('(?i)(?:[^0-9]+(?:under 16-13-2)? - cnt \d+ (?:accusation-)?|\n(?:by|against) )',
                             '(?!warrantless|accusation|uniform|arrest|indictment|county|traffic|criminal|bad check|no bill)',
                             '((?:(?! -).)+)(?<! )')),
    'Bench Warrant': ''.join(('(?i)(?:.ssued|.equested)(?: (.+))?|',
                 '(?:true (?:bill )?|order (?:granting|for) )?bench warrant',
                 '(?: (?:issued(?: failure to appear)?|for failure to appear|requested))?',
                 '(?:(?:\n| ?- ?|  +| filed )(?:against )?((?:.|\n)+)| +& bond forfeiture)?')),
    'Calendar': ''.join(('(?i)(?:(?:\d\d:\d\d (?:a|p)m|1st appearence hearing) |',
                 '(?:.+)?(?:calendar|hearing)|(?:traffic bench )?trial|arraignment|plea|pre-trial conference|',
                 '[a-z/ ]+\nagainst (.+))$')),
    'FiFa Issued': ''.join(('(?i)(?:fifa issued|(?:fifa issued\n)?fifa +(?:[a-z ]+ \d*\.\d+(?: +|\n)?)+',
                 '(?:judge?ment against +(.+)(?:\n)?)*)',
                 '(?:(?:mailed )?(?:original )?fifa (?:mailed )?to att(?:orne)?y .+(?:\n(?:on )?[0-9/\-]+)?)?')),
    'Fifa issued': ''.join(('(?i)(?:fifa issued|(?:fifa issued\n)?fifa +(?:[a-z ]+ \d*\.\d+(?: +|\n)?)+',
                 '(?:judge?ment against +(.+)(?:\n)?)*)',
                 '(?:(?:mailed )?(?:original )?fifa (?:mailed )?to att(?:orne)?y .+(?:\n(?:on )?[0-9/\-]+)?)?')),
    'Alias Fifa': ''.join(('(?i)(?:alias fifa|(?:alias fifa\n)?fifa +(?:[a-z ]+ \d*\.\d+(?: +|\n)?)+',
                 '(?:judge?ment against +(.+)(?:\n)?)*)',
                 '(?:(?:mailed )?(?:original )?fifa (?:mailed )?to att(?:orne)?y .+(?:\n(?:on )?[0-9/\-]+)?)?')),
    'Answer': ''.join(('(?i)(?:(?:.|\n)+(?:(?:filed )?(?<=[^a-z])by (.+))+|',
                 '(?:[a-z0-9,@\.\'\- ]*(?:answ|resp|reply|dispo)|(?:defendant|deft|def ))(?:.|\n)*)')),
    'Judgment': ''.join(('(?i)(?:judgment +(?:(?:[a-z ]+ \d*\.\d+|no charges)(?: +|\n)?)+',
                 '(?:judge?ment against +(.+)(?:\n)?)*|judgment)')),
    'Entry of Appear': ''.join(('(?i)(?:(?:amended|substitute|entry and|notice of|limited scope) )?',
                 '(?:(?:entry|notice) of appear(?:ance)?|(?:(?:not of )?substitution of )?counsel)',
                 '(?:(?: (?:atty|by|for|of) [a-z&\. ]+)?(?:\nby (.+))*|(?:.|\n)*)')),
    'Party Inactive': '(?i)((?:(?!j(?:udg)?ment|ag(?:ree)?me?nt).)*)$',
    'Proposed Order': '(?i)(?:\[?proposed\]?|default|consent|order) .+(?:(?:for|to|of|and)\n.+)*(?:\nby (.+))*',
    'Div Parent Cert': ''.join(('(?i)(?:divorcing parents|parenting(?: seminar)?) certificate(?: *\-? ?\(?',
                 '(?:deft|pltf|(?:(?:for|by) (?:(?:plaintiff|defendant)(?:\:| \-)? )?)?([^)\n]+))\)?)?',
                 '(?:\n(?:filed )?(?:(?:by|for) )?(.+))?')),
    'Plea': ''.join(('(?i)(?:ct [0-9ivx]+ (?:- )?)?(?:[a-z ]*plea[a-z ]*|nolo contendere|mental incompetence)',
                 '(?:\(recorded live\))?(?: - cn?(?:t \d+)?| (?:- )?ct \d+(?: -)?)?',
                 '(?: \((.+)\)|(?: ?- ?|/)([a-z,\.\- ]+))?(?:\n(?:by|for(?: def)?) (.+))?')),
    'Jury Demand': ''.join(('(?i)(?:[a-z0-9\- ]*jury[a-z0-9\- ]*(?:\n(?:filed )?(?:by|for|against) (.+))*|',
                 'defendant (.+) (?:jury|demand)(?:.|\n)+)')),
    'Dem for Discov': ''.join(('(?i)(?:[a-z&\'\,\. ]*(?:demand|discovery|notice)[a-z&\'\,\. ]*',
                 '(?:(?:\(defendant)? ?- ?([a-z ]+)\)?)?',
                 '(?:(?:\n.+)?\n(?:by|for|against) (.+))?(?:\ncertificate of service)?|',
                 '(?:state\'s )?demand for discovery(?:(?:\n)?[a-z ]+state[a-z ]*)?\n([a-z, ]+))')),
    'Suspended Sente': ''.join(('(?i)suspended sentence division - due date \d{2}/\d{2}/\d{4}(?:\nagainst (.+))?',
                 '(?:\n(?:due|agreement) date updated to \d{2}/\d{2}/\d{4})*')),
    "Pauper's Affida": ''.join(('(?i)(?:amended )?',
                 '(?:pauper\'?s affi?da?vi?t|affidavit of poverty|request to proceed in forma pauperis)',
                 '(?:[a-z\- ]*(?:attachment|amended|approved)[a-z\- ]*)?(?:\nby (.+))?')),
    'Atty Lv of Abs': ''.join(('(?i)(?:(?:\n)?(?:amended )?(?:lea atty [a-z&,/\-\.\'0-9\(\) ]+|',
                 '[a-z\-\.0-9 ]*(?:leave of absence|loa)[a-z&,/\-\.\'0-9\(\) ]*)',
                 '(?:\n(?:plaintiff|defendant|non-party|by) (.+))?(?:\n[0-9/\- ]+)*|[0-9/\- ]+){,5}')),
    'Service Postcrd': '(?i)service of [a-z]{4} on \d{2}/\d{2}/\d{4} at \d{2}:\d{2} (?:a|p)m\nfor (.+)',
    'Receipt': ''.join(('(?i)(?:receipt#? \d+ issued(?:(?: |\n)',
                 '(?:(?:for|with) )?\$\d*(?:\.\d+)?[a-z\. ]*)?(?:\n.+paid in full(?:.|\n)+)?',
                 '(?:\n(?:deft p(?:ai)?d|(?:for )?pidp)(?:.|\n)+)?(?:\nby (.+))?|r# +00)')),
    'Wthdr of Counsl': ''.join(('(?i)(?:(?:order|emergency) )?withdrawal of counsel(?:.+(?:order|grant).*)?',
                                '(?:[a-z ]+ for (?:pltf|deft))?(?:(?:\n| )by (.+))?')),
    'CAS# Org Format': '(?i)conversion from case number \([a-z0-9]+ ?\)',
    'Bond set': ''.join(('(?i)bond (?:(?:set at|changed to) \$[0-9\.]+|(?:considered and )?denied(?:\([0-9\-]+\))?',
                         '(?: pending hearing)?)(?: by judge [a-z]+)?(?:\nspecial conditions on bond)?')),
    'Case Transfered': '(?i)transfer(?: out of county|(?:red)? to [a-z]+(?: court)?(?: case# [a-z0-9]+| - cnt \d+)?)',
    'Party ID': '(?i)defendant id on warrant app',
    'Conversion Note': '(?i)(?:case status(?: \- |:)[a-z ]+|[a-z ]+ticket number \d+|continuances  \d+)',
    'Rule NISI': ''.join(('(?i)(?:(?:(?:summons|order) (?:and|&) )?rule nisi(?: - (?:appear)?)? *',
                          '[0-9a-z/\-, ]+ ?@? ?[0-9:]+ ?(?:a|p)\.?m\.?(?: room \d+)?|(?:rule|nisi|rule ?nisi))')),
    'Continuance': ''.join(('(?i)continu(?:ance by order(?: to)?|ed(?: not reached)?)',
                            '(?:(?: ?- appear| and judgment(?: -)?)?(?: +|\n)[0-9\-:/@apm ]+)?(?:(?:\n)?room \d+)?')),
    'Judge Reassign': ''.join(('(?i)from [a-z0-9\., ]* to [a-z0-9\., ]*(?:\n(?:',
                               '(?:prior|prev|jury|drug|judge [a-z]+ retired).+|no bill|co-defs?))?')),
    'Prob Case close': '(?i)probation case closed(?:\n(?:(?:for|by)(?: def)?|deft) (.+))?',
    'Stipulation': ''.join(('(?i)(?:stipulated by (?:plaintiff|defendant)|notice of stipulation(?: to active list)?)',
                            '(?:(?: to)?(?: ?(?:\-|/))? +(?:non)?(?:-| )?jury(?: cal(?:end(?:a|e)r)?)?)?',
                            '(?:\n(?:filed )?by (.+))*')),
    'Arr War Probter': ''.join(('(?i)(?:a|x)rrest warrant for probationer(?:-(?:deft|against) (.+)|',
                                '\n(?:for|against) (?:deft? )?(.+)| ?\((.+)\)|/ ?(?:tolling order|(.+)))?')),
    'Check Issued': '(?i)check \d+ issued for \$[0-9\.]+ ?on [0-9/]+',
    'Pet for Vop': '(?i)pet(?:ition)? for (?:(?:violation|(?:modification/)?revocation) of probation|adjudication of guilt)',
    'Pet for VOP': '(?i)pet for violation of probation(?:/modification)?(?:\nfor deft? (.+))?',
    'Viol of Prob': '(?i)(?:violation of probation|probation revoked|oag)',
    'Crt Rpt Cert': '(?i)court reporters cert of recd(?:\n(?:for|by|deft) (.+))?',
    'Garn Answer Fil': '(?i)garnishment answer filed',
    'Off Code Change': '(?i)from [a-z0-9/&,<+\-\.\(\) ]+ to [a-z0-9/&,<+\-\.\(\) ]+(?:\nby (.+))*',
    'Rec Shr Service': ''.join(('(?i)(?:service copy sent to sheriff department|received for sheriff service|',
                                'copy(?: of indictments?)?(?: sent| given)? to (?:da|district attorney)(?:\'s)? office|',
                                'indictments? [0-9/]+)')),
    'Plea in Absenti': '(?i)plea in absentia',
    'Garn/Reg Notice': '(?i)attorney notice printed for receipt \d+',
    'DPS 912 Transm': '(?i)(?:dmvs batch #: \d+|dps 912 transmission)',
    'DPS 912 WTH Trn': '(?i)(?:dmvs batch #: \d+|dps 912 withdrawal transmissio)',
    'DPS912 printed': '(?i)dps (?:912 notice|form) printed',
    'Appl. Ind. Atty': '(?i)(?:a|x)ppl\.?(?: for indigent counsel| & ord (?:for|denying) appt of counsel)',
    'Counsel of Ind': '(?i)(?:denied|granted(?: - panel atty)?)(?:\nvop|\nby (.+))?',
    'Sentence FOA': '(?i)(?:sentenced/first offender act|first offender probation)',
    'Sent Modified': '(?i)sentence (?:(?:rev/)?modified|amended)',
    'Transcript': ''.join(('(?i)(?:[a-z\. ]+ )?transcr(?:ipt)?(?: ([a-z ]+)| +(?:\- )?\{?[0-9/]+\}?(?:(?:\n| )(.+))?|',
                           '(?:\n| - )first offender|(?:\n| )(?:volume|section) \d+| ?- ?(.+)| \((.+)\))?')),
    'Conv - PER Cont': '(?i)# of peremptory continuances - \d+',
    'Dem for Disc': ''.join(('(?i)(?:(?:consolidated |amended )?demand for (?:statutory )?discovery',
                             '(?: & notice to produce)?|defendant\'s list of witnesses)(?:\n(?:by|for) (.+))?')),
    'Arrest Order': '(?i)(?:arrest order|warrant for arrest of probationer(?: -)?(?: (.+))?|issued (.+))',
    'Image Copy': ''.join(('(?i)(?:warrantless arrest affidavit|order (?:for|to reduce) bond|waiver of prelim hearing|',
                           'appl(?:\.|ication) for (?:indigent counsel|arrest warrant)|',
                           '(?:order for|consent bond) (?:(?:bond|ord) w/spec conds|continuance)|',
                           'bindover for superior court|entry of appearance|ct rep\. cert of recordation|',
                           '(?:not )?guilty plea(?:-negotiated - cnt \d+)?|order|case field report|motion filed)'))
}
